<?php
/*****************************************************************************/
/* Errors.php                                                                */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$errorsphpver = 'YaBB SE 1.5.1';

function database_error($file = "", $line = "")
{
	global $txt, $settings, $db_prefix, $ID_MEMBER, $REMOTE_ADDR, $REQUEST_URI, $modSettings;
	$query_error = mysql_error();

	// log the error
	if ($modSettings['enableErrorLogging'] == 1)
		$request = mysql_query("
			INSERT INTO {$db_prefix}log_errors (logTime, ID_MEMBER, IP, url, message)
			VALUES ('" . time() . "', $ID_MEMBER, '$REMOTE_ADDR', '$REQUEST_URI', '" . mysql_escape_string("$txt[1001]: $query_error\r\n$txt[1003]: $file\r\n$txt[1004]: $line") . "');");

	// show an error message
	$error = ($settings[7] == 'Administrator' || $settings[7] == 'Global Moderator') ?  "$query_error<br />$txt[1003]: $file<br />$txt[1004]: $line" : $txt[1002];
	fatal_error($error, $txt[1001]);
}

function fatal_error($e, $t = null)
{
	global $txt, $color, $yytitle, $yyheaderdone, $db_prefix, $ID_MEMBER, $REMOTE_ADDR, $REQUEST_URI, $modSettings;

	if ($t == null)
		$yytitle = $txt[106];
	else
		$yytitle = $t;
	if (!$yyheaderdone)
		template_header();
	echo '
		<table border="0" width="80%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center" cellpadding="4">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $yytitle . '</b></font></td>
			</tr><tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '"><br /><font size="2">' . $e . '</font><br /><br /></td>
			</tr>
		</table>
		<div align="center"><br /><a href="javascript:history.go(-1)">' . $txt[250] . '</a></div>';
	// now log the error
	if ($t == null && $modSettings['enableErrorLogging'] == 1)
		$request = mysql_query("
			INSERT INTO {$db_prefix}log_errors (logTime, ID_MEMBER, IP, url, message)
			VALUES ('" . time() . "', $ID_MEMBER, '$REMOTE_ADDR', '$REQUEST_URI', '" . mysql_escape_string($e) . "');");
	footer();
	obExit();
}

function ViewErrorLog()
{
	global $db_prefix, $cgi, $txt, $imagesdir, $color, $yytitle, $sc;
	// verify the user is an administrator
	is_admin();
	$yytitle = $txt['errlog1'];
	template_header();
	$request = mysql_query("
		SELECT le.ID_ERROR, le.IP, le.url, IFNULL(mem.memberName, 'Guest') AS memberName, le.logTime, le.message 
		FROM {$db_prefix}log_errors AS le
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=le.ID_MEMBER)
		ORDER BY le.logTime;") or database_error(__FILE__, __LINE__);
	echo '
		<form action="' . $cgi . ';action=deleteErrors" method="post">
			<table border="0" cellspacing="1" cellpadding="5" class="bordercolor" align="center">
				<tr>
					<td class="titlebg" colspan="2"><img src="' . $imagesdir . '/xx.gif" alt="" border="0" />&nbsp;<font size="2" color="' . $color['titletext'] . '"><b>' . $txt['errlog1'] . '</b></font></td>
				</tr><tr>
					<td colspan="2" class="windowbg"><font size="2">' . $txt['errlog2'] . '</font></td>
				</tr>';
	while ($row = mysql_fetch_array($request))
	{
		$errorDate = timeformat($row['logTime']);
		$row['memberName'] = htmlspecialchars($row['memberName']);
		$row['url'] = htmlspecialchars($row['url']);
		$row['message'] = htmlspecialchars($row['message']);
		echo '
				<tr>
					<td width="15" align="center" class="windowbg2"><input type="checkbox" name="delete_' . $row['ID_ERROR'] . '" value="delete_' . $row['ID_ERROR'] . '" /></td>
					<td class="windowbg2" width="100%"><b>' . $row['memberName'] . '</b> : <b>' . $row['IP'] . '</b> : <b>' . $errorDate . '</b><br /><a href="' . $row['url'] . '">' . $row['url'] . '</a><br />' .  preg_replace("/\r\n/", "<br \/>", $row['message']) . '</td>
				</tr>';
	}
	echo '
			</table><br />
			<input type="submit" value="' . $txt[31] . '" />&nbsp;&nbsp;<input type="submit" name="delall" value="' . $txt['yse219'] . '" />
			<input type="hidden" name="sc" value="' . $sc . '" />
		</form>';
	footer();
	obExit();
}

function DeleteErrors()
{
	global $HTTP_POST_VARS, $db_prefix, $delall;

	checkSession();
	// verify the user is an administrator
	is_admin();
	if ($delall)
	{
		$request = mysql_query("DELETE FROM {$db_prefix}log_errors;") or database_error(__FILE__, __LINE__);
		ViewErrorLog();
	}
	foreach ($HTTP_POST_VARS as $postVar=>$postVarValue)
	{
		if (strcmp(substr($postVar, 0, 7), "delete_") == 0)
		{
			$id = substr($postVar, 7);
			$request = mysql_query("DELETE FROM {$db_prefix}log_errors WHERE ID_ERROR='$id';") or database_error(__FILE__, __LINE__);
		}
	}
	ViewErrorLog();
}
?>