<?php
/*****************************************************************************/
/* Repair.php                                                                */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$repairboardsphpver = 'YaBB SE 1.5.1';

function RepairBoards()
{
	global $db_prefix, $fixErrors, $txt, $scripturl, $salvageCatID, $salvageBoardID, $yytitle;

//Make sure the user is an admin
	is_admin();

//print out the top of the webpage
	$yytitle   = $txt[610];
	template_header();

//Giant if/else. The first displays the forum errors if a variable is not set and asks if you would like to continue,
//the other fixes the errors.

####Start displaying errors without fixing them.####
	if (!isset($fixErrors))
		$fixErrors = "0";

	if ($fixErrors == "0")
	{
		echo '
			<table width="100%" cellspacing="0" cellpadding="10" align="center" bgcolor="#FFFFFF">
				<tr> 
					<td width="100%" valign="top">
						<table width="100%" border="0" cellspacing="1" bgcolor="#6394BD" class="bordercolor">
							<tr>
								<td bgcolor="#6E94B7" class="titlebg"><font size="2" color="#FFFFFF" class="text1"><b>' . $txt['yse73'] . '</b></font></td>
							</tr><tr>
								<td bgcolor="#AFC6DB" class="windowbg">
									' . $txt['yse74'] . ':<p>';

		$resultMsg = mysql_query("
			SELECT m.ID_TOPIC, m.ID_MSG
			FROM {$db_prefix}messages AS m
				LEFT JOIN {$db_prefix}topics AS t ON (t.ID_TOPIC=m.ID_TOPIC)
			WHERE t.ID_TOPIC IS NULL
			ORDER BY m.ID_TOPIC,m.ID_MSG") or database_error(__FILE__, __LINE__);

		if (mysql_num_rows($resultMsg) > 0) 
			while ($msgArray = mysql_fetch_array($resultMsg))
				echo "$txt[72] $msgArray[ID_MSG] $txt[yse307]: $msgArray[ID_TOPIC]<br />";


		$resultTopic = mysql_query("
			SELECT t.ID_TOPIC, COUNT(m.ID_MSG) AS numMsg
			FROM {$db_prefix}topics AS t
				LEFT JOIN {$db_prefix}messages AS m ON (m.ID_TOPIC=t.ID_TOPIC)
			GROUP BY t.ID_TOPIC
			HAVING numMsg=0
			ORDER BY ID_TOPIC") or database_error(__FILE__, __LINE__);

		if (mysql_num_rows($resultTopic) > 0) 
			while ($topicArray = mysql_fetch_array($resultTopic))
				echo "$txt[118] $topicArray[ID_TOPIC] $txt[yse308]<br />";

		$resultTopic = mysql_query("
			SELECT t.ID_TOPIC, MIN(m.ID_MSG) AS myID_FIRST_MSG, t.ID_FIRST_MSG, MAX(m.ID_MSG) AS myID_LAST_MSG, t.ID_LAST_MSG, COUNT(m.ID_MSG) - 1 AS myNumReplies, t.numReplies
			FROM {$db_prefix}topics AS t
				LEFT JOIN {$db_prefix}messages AS m ON (m.ID_TOPIC=t.ID_TOPIC)
			GROUP BY t.ID_TOPIC
			HAVING ID_FIRST_MSG<>myID_FIRST_MSG OR ID_LAST_MSG<>myID_LAST_MSG OR numReplies<>myNumReplies
			ORDER BY t.ID_TOPIC") or database_error(__FILE__, __LINE__);

		if (mysql_num_rows($resultTopic) > 0)
			while ($topicArray = mysql_fetch_array($resultTopic))
			{
				if ($topicArray['ID_FIRST_MSG'] != $topicArray['myID_FIRST_MSG'])
					echo "$txt[118] $topicArray[ID_TOPIC] $txt[yse75]: $topicArray[ID_FIRST_MSG]<br />";
				if ($topicArray['ID_LAST_MSG'] != $topicArray['myID_LAST_MSG'])
					echo "$txt[118] $topicArray[ID_TOPIC] $txt[yse76]: $topicArray[ID_LAST_MSG]<br />";
				if ($topicArray['numReplies'] != $topicArray['myNumReplies'])
					echo "$txt[118] $topicArray[ID_TOPIC] $txt[yse309]: $topicArray[numReplies]<br />";
			}

		$resultTopics = mysql_query("
			SELECT t.ID_TOPIC, t.ID_BOARD
			FROM {$db_prefix}topics AS t
				LEFT JOIN {$db_prefix}boards AS b ON (b.ID_BOARD=t.ID_BOARD)
			WHERE b.ID_BOARD IS NULL
			ORDER BY t.ID_BOARD,t.ID_TOPIC") or database_error(__FILE__, __LINE__);
		
		if (mysql_num_rows($resultTopics) > 0) 
			while ($topicArray = mysql_fetch_array($resultTopics))
				echo "$txt[118] $topicArray[ID_TOPIC] $txt[yse81] ($txt[yse82] $topicArray[ID_BOARD]).<br />";

		$resultBoards = mysql_query("
			SELECT b.ID_BOARD, b.ID_CAT
			FROM {$db_prefix}boards AS b
				LEFT JOIN {$db_prefix}categories AS c ON (c.ID_CAT=b.ID_CAT)
			WHERE c.ID_CAT IS NULL
			ORDER BY b.ID_CAT,b.ID_BOARD") or database_error(__FILE__, __LINE__);
			
		if (mysql_num_rows($resultBoards) > 0) 
			while ($boardArray = mysql_fetch_array($resultBoards))
				echo "$txt[yse82] $boardArray[ID_BOARD] $txt[yse83] ($txt[yse84] $boardArray[ID_CAT]).<br />";
	
		$resultMsg = mysql_query("
			SELECT m.ID_MSG
			FROM {$db_prefix}messages AS m
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=m.ID_MEMBER)
			WHERE m.ID_MEMBER != '-1'
				AND mem.ID_MEMBER IS NULL;") or database_error(__FILE__, __LINE__);

		if (mysql_num_rows($resultMsg) > 0) 
			while ($msgArray = mysql_fetch_array($resultMsg))
				echo "$txt[72] $boardArray[ID_MSG] $txt[yse310].<br />";
		
		
		
		echo '
									</p>
									<p><font size="2">' . $txt['yse85'] . '</font><br />
									<b><a href="?action=repairboards;fixErrors=1">' . $txt[163] . '</a> - <a href="?action=admin">' . $txt[164] . '</a></b></p>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>';
	}
	elseif ($fixErrors == "1")
	{
		echo '
			<table width="100%" cellspacing="0" cellpadding="10" align="center" bgcolor="#FFFFFF">
				<tr> 
					<td width="100%" valign="top">
						<table width="100%" border="0" cellspacing="1" bgcolor="#6394BD" class="bordercolor">
							<tr>
								<td bgcolor="#6E94B7" class="titlebg"><font size="2" color="#FFFFFF" class="text1"><b>' . $txt['yse86'] . '</b></font></td>
							</tr><tr>
								<td bgcolor="#AFC6DB" class="windowbg">';

		//variable to be sure that salvage cats/boards only get created once
		$createOnce = "0";

		// Fix all messages that have a topic ID that cannot be found in the topics table
			$resultMsg = mysql_query("
				SELECT m.ID_TOPIC, MIN(m.ID_MSG) AS myID_FIRST_MSG, MAX(m.ID_MSG) AS myID_LAST_MSG, COUNT(m.ID_MSG) - 1 AS myNumReplies
				FROM {$db_prefix}messages AS m
					LEFT JOIN {$db_prefix}topics AS t ON (t.ID_TOPIC=m.ID_TOPIC)
				WHERE t.ID_TOPIC IS NULL
				GROUP BY m.ID_TOPIC") or database_error(__FILE__, __LINE__);
			
			if (mysql_num_rows($resultMsg) > 0) 
			{
				createSalvageArea();

				while ($msgArray = mysql_fetch_array($resultMsg))
				{
					$memberStartedID = getMemberID($msgArray['myID_FIRST_MSG']);
					$memberUpdatedID = getMemberID($msgArray['myID_LAST_MSG']);
					
					$result = mysql_query("
						INSERT INTO {$db_prefix}topics (ID_BOARD, ID_MEMBER_STARTED, ID_MEMBER_UPDATED, ID_FIRST_MSG, ID_LAST_MSG, numReplies)
						VALUES ('$salvageBoardID', '$memberStartedID', '$memberUpdatedID', '$msgArray[myID_FIRST_MSG]', '$msgArray[myID_LAST_MSG]', '$msgArray[myNumReplies]')") or database_error(__FILE__, __LINE__);
					$newTopicID = mysql_insert_id();
					
					$result = mysql_query("UPDATE {$db_prefix}messages SET ID_TOPIC=$newTopicID WHERE ID_TOPIC=$msgArray[ID_TOPIC]") or database_error(__FILE__, __LINE__);
					echo "<br />";

				}
			}
			echo '<br />';
		// ***

		// Remove all topics that have zero messages in the messages table
			$resultTopic = mysql_query("
				SELECT t.ID_TOPIC, COUNT(m.ID_MSG) AS numMsg
				FROM {$db_prefix}topics AS t
					LEFT JOIN {$db_prefix}messages AS m ON (m.ID_TOPIC=t.ID_TOPIC)
				GROUP BY t.ID_TOPIC
				HAVING numMsg=0") or database_error(__FILE__, __LINE__);

			if (mysql_num_rows($resultTopic) > 0) 
			{
				$stupidTopics = array();
				while ($topicArray = mysql_fetch_array($resultTopic))
					$stupidTopics[] = $topicArray['ID_TOPIC'];
				$result = mysql_query("DELETE FROM {$db_prefix}topics WHERE ID_TOPIC IN (" . implode(',', $stupidTopics) . ')') or database_error(__FILE__, __LINE__);
				echo mysql_affected_rows() . " $txt[yse312]<br />";
			}
		// ***

		// Fix all ID_FIRST_MSG, ID_LAST_MSG and numReplies in the topic table
			$resultTopic = mysql_query("
				SELECT t.ID_TOPIC, MIN(m.ID_MSG) AS myID_FIRST_MSG, t.ID_FIRST_MSG, MAX(m.ID_MSG) AS myID_LAST_MSG, t.ID_LAST_MSG, COUNT(m.ID_MSG) - 1 AS myNumReplies, t.numReplies
				FROM {$db_prefix}topics AS t
					LEFT JOIN {$db_prefix}messages AS m ON (m.ID_TOPIC=t.ID_TOPIC)
				GROUP BY t.ID_TOPIC
				HAVING ID_FIRST_MSG<>myID_FIRST_MSG OR ID_LAST_MSG<>myID_LAST_MSG OR numReplies<>myNumReplies") or database_error(__FILE__, __LINE__);
			
			if (mysql_num_rows($resultTopic) > 0) 
			{
				while ($topicArray = mysql_fetch_array($resultTopic))
				{
					$memberStartedID = getMemberID($topicArray['myID_FIRST_MSG']);
					$memberUpdatedID = getMemberID($topicArray['myID_LAST_MSG']);
					$result = mysql_query("
						UPDATE {$db_prefix}topics
						SET ID_FIRST_MSG='$topicArray[myID_FIRST_MSG]', ID_MEMBER_STARTED='$memberStartedID', ID_LAST_MSG=$topicArray[myID_LAST_MSG], ID_MEMBER_UPDATED='$memberUpdatedID', numReplies='$topicArray[myNumReplies]'
						WHERE ID_TOPIC=$topicArray[ID_TOPIC]") or database_error(__FILE__, __LINE__);
				}
			}
		// ***

		// Fix all topics that have a board ID that cannot be found in the boards table
			$resultTopics = mysql_query("
				SELECT t.ID_BOARD, COUNT(t.ID_TOPIC) AS myNumTopics, COUNT(m.ID_MSG) AS myNumPosts
				FROM {$db_prefix}topics AS t
					LEFT JOIN {$db_prefix}boards AS b ON (b.ID_BOARD=t.ID_BOARD)
					LEFT JOIN {$db_prefix}messages AS m ON (m.ID_TOPIC=t.ID_TOPIC)
				WHERE b.ID_BOARD IS NULL
				GROUP BY t.ID_BOARD") or database_error(__FILE__, __LINE__);
			
			if (mysql_num_rows($resultTopics) > 0) 
			{
				createSalvageArea();

				while ($topicArray = mysql_fetch_array($resultTopics))
				{
					$result = mysql_query("
						INSERT INTO {$db_prefix}boards (ID_CAT, name, numTopics, numPosts)
						VALUES ('$salvageCatID', 'Salvaged board', '$topicArray[myNumTopics]', '$topicArray[myNumPosts]')") or database_error(__FILE__, __LINE__);
					$newBoardID = mysql_insert_id();
					
					$result = mysql_query("UPDATE {$db_prefix}topics SET ID_BOARD=$newBoardID WHERE ID_BOARD=$topicArray[ID_BOARD]") or database_error(__FILE__, __LINE__);
					echo "$txt[yse311]<br />";

				}
			}
		// ***

		// Fix all boards that have a cat ID that cannot be found in the cats table
			$resultBoards = mysql_query("
				SELECT b.ID_CAT
				FROM {$db_prefix}boards AS b
					LEFT JOIN {$db_prefix}categories AS c ON (c.ID_CAT=b.ID_CAT)
				WHERE c.ID_CAT IS NULL
				GROUP BY b.ID_CAT") or database_error(__FILE__, __LINE__);
			
			if (mysql_num_rows($resultBoards) > 0) 
			{
				createSalvageArea();

				while ($boardArray = mysql_fetch_array($resultBoards))
				{
					$result = mysql_query("UPDATE {$db_prefix}boards SET ID_CAT=$salvageCatID WHERE ID_BOARD=$boardArray[ID_CAT]") or database_error(__FILE__, __LINE__);
					echo "$txt[yse311]<br />";

				}
			}
		// ***

		//Last step-make sure all non-guest posters still exist

			$resultMsg = mysql_query("
				SELECT m.ID_MSG
				FROM {$db_prefix}messages AS m
					LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=m.ID_MEMBER)
				WHERE m.ID_MEMBER != '-1'
					AND mem.ID_MEMBER IS NULL;") or database_error(__FILE__, __LINE__);
		
			if (mysql_num_rows($resultMsg) > 0) 
			{
				$guestMessages = array();
				while ($msgArray = mysql_fetch_array($resultMsg))
					$guestMessages[] = $msgArray['ID_MSG'];
				$result = mysql_query("UPDATE {$db_prefix}messages SET ID_MEMBER='-1' WHERE ID_MSG IN (" . implode(',', $guestMessages) . ')') or database_error(__FILE__, __LINE__);
			}

		updateStats('message');
		updateStats('topic');

		echo '
									<font size="2"><p>' . $txt['yse92'] . '</p>
									<a href="?action=admin">' . $txt[137] . '</a><br />
									<a href="' . $scripturl . '">' . $txt[236] . ' ' . $txt[237] . '</a><br /></font>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>';











	}
	footer();
	obExit();
}




function createSalvageArea()
{
	global $createOnce, $db_prefix, $salvageBoardID, $salvageCatID;

	if ($createOnce < 1)
	{
		// check to see if a 'Salvage Category' exists, if not => insert one
		$result = mysql_query("SELECT ID_CAT FROM {$db_prefix}categories WHERE name='Salvage Area'") or database_error(__FILE__, __LINE__);
		if (mysql_num_rows($result) == 0)
		{
			mysql_query("
				INSERT INTO {$db_prefix}categories (name,memberGroups,catOrder)
				VALUES ('Salvage Area','Administrator','-1');") or database_error(__FILE__, __LINE__);
			if (mysql_affected_rows() <= 0)
				fatal_error("$txt[yse89] $txt[yse82]");
			$result = mysql_query("SELECT ID_CAT FROM {$db_prefix}categories WHERE name='Salvage Area';") or database_error(__FILE__, __LINE__);
		}
		$arraySalvage = mysql_fetch_array($result);
		$salvageCatID = $arraySalvage['ID_CAT'];

		// check to see if a 'Salvage Board' exists, if not => insert one
		$result = mysql_query("SELECT IFNULL(ID_BOARD,0) AS ID_BOARD FROM {$db_prefix}boards WHERE ID_CAT=$salvageCatID AND name='Salvaged Messages'") or database_error(__FILE__, __LINE__);
		if (mysql_num_rows($result) == 0)
		{
			mysql_query("
				INSERT INTO {$db_prefix}boards (name, description, moderators, ID_CAT)
				VALUES ('Salvaged Messages', 'Topics created for messages with non-existant topic ids', '', '$salvageCatID');") or database_error(__FILE__, __LINE__);
			if (mysql_affected_rows() < 0)
				fatal_error("$txt[yse89] $txt[yse84]");
			$result = mysql_query("SELECT ID_BOARD FROM {$db_prefix}boards WHERE ID_CAT=$salvageCatID AND name='Salvaged Messages'") or database_error(__FILE__, __LINE__);
		}
		else
		$arraySalvage = mysql_fetch_array($result);
		$salvageBoardID = $arraySalvage['ID_BOARD'];

		$createOnce = 1;
	}
}

?>